<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Chaitin!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>Iteratív és rekurzív faktoriális Lisp-ben</title>
        <para>
                
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/z6NJE2a1zIA">https://youtu.be/z6NJE2a1zIA</link>      
        </para>
        <para>
            Megoldás forrása:                
        </para>
        <para>
            A Lisp "List Processing" programnyelvet fogja bemutatni a következő példa program, ez a program nyelv már 50-es évek legvégétől létezett. 
            Eredetileg általános célú programnyelvnek tervezték, de végül mesterséges intelligencia kutatására alkalmazták legtöbbet. 
            A nevéből kiindulva is lehet következtetni, hogy a programnyelvnek adatstruktúrája láncolt. Egy Lisp programot már ránézésre is 
            fel lehet ismerni a szintaktikája miatt, ugyanis a programkód egymásba ágyazott listák, azaz zárójelezett, 
            ún. S-kifejezések (S-expression, sexp) sorozata. A tömör kifejezhetősége, és gépi elemzés miatt terjedt el többnyire a 60-as években.
        </para>
        <programlisting language="lisp"><![CDATA[
#!/usr/bin/clisp

(defun factorial_iterative (n)
	(let ((f 1))
		(dotimes (i n)
		(setf f (* f (+ i 1))))
		f
	)
)
]]>
        </programlisting>
        <para>
            Ebben a programban definiáljuk a legelején a "factorial_iterative" iteratív faktoriálist függvényt. Vesz a program egy lokális 
            változót "f 1", és majd a dotimes (i n) fogja vezérelni a számolást, ami a f-re fog végrehajtódni "(* f (+ i 1))" művelettel.
        </para>
        <programlisting language="lisp"><![CDATA[
(defun factorial_recursive (n)
  (if (= n 0)
      1
      (* n (factorial_recursive (- n 1))) ) )
]]>
        </programlisting>
        <para>
              A rekurzív faktoriális függvénynél is hasonlóan kell definiálni mint az előzőt, itt megvizsgáljuk hogy ha n = 0, akkor 
              az eredmény 1 legyen, mivel matematikusok rég megegyeztek hogy a 0 faktoriális eredménye mindig 1 legyen. Majd jön a 
              faktoriális számítás: n * (n-1). 
        </para>
        <programlisting language="lisp"><![CDATA[
(format t "Recursive:~%")

(loop for i from 0 to 20
	do (format t "~D! = ~D~%" i (factorial_recursive i)) )
]]></programlisting>
        <para>
            A loop-ban for ciklus van, megadjuk a ciklus változót, és mettől-meddig menjen. A do után kiiratjuk a számokat (~D-vel), először is 
            A második formátum string pedig lesz az amire elvégezzük a függvényt, és ezt természetesen meghívjuk. A "~%" jelölés új sort takar.
        </para>
<programlisting language="lisp"><![CDATA[
(format t "Iterative:~%")

(loop for i from 0 to 20
	do (format t "~D! = ~D~%" i (factorial_iterative i)) )
]]></programlisting>
        <para>
            A legvégén pedig található az iteratív függvény kiszámítása, és kiírása. Ugyanúgy mint a rekurzív függvényt csak más függvény meghívás található.    
        </para>
    </section>        
<!--        
    <section>
        <title>Weizenbaum Eliza programja</title>
        <para>
            Éleszd fel Weizenbaum Eliza programját!
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:                
        </para>
    </section>        
-->
   

    <section>
        <title>Gimp Scheme Script-fu: név mandala</title>
        <para>
            Írj olyan script-fu kiterjesztést a GIMP programhoz, amely név-mandalát készít a
            bemenő szövegből!               
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://bhaxor.blog.hu/2019/01/10/a_gimp_lisp_hackelese_a_scheme_programozasi_nyelv">https://bhaxor.blog.hu/2019/01/10/a_gimp_lisp_hackelese_a_scheme_programozasi_nyelv</link>      
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/GIMP_Lisp/Mandala">https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/GIMP_Lisp/Mandala</link>               
        </para>
        <para>
            A következő program ugyan azzal a programnyelvet használ, de most egy név mandalát készít, a bemenő szövegből.
        </para>
        <para>
            Mandala, egy vallási ábrázolás. Sokan rajzolják meditáció gyanánt. A szó, az ősi indiai nyelvből, a szanszkritből származik. 
            Az alakja egy koronghoz hasonlít leginkább, ami egy virág felülnézetéből áll össze. A program is ezt próbálja majd reprezentálni, 
            csak nem virágmintával, hanem szöveggel.
        </para>
        <programlisting language="lisp"><![CDATA[
(define (elem x lista)

    (if (= x 1) (car lista) (elem (- x 1) ( cdr lista ) ) )

)
]]></programlisting>
        <para>
            Megint csak lista függvénnyel kezd a forráskód, ami car változó a lista első elemét nézi, a cdr az összes többi elemet.
        </para> 
        <programlisting language="lisp"><![CDATA[
(define (text-width text font fontsize)
(let*
    (
        (text-width 1)
    )
    (set! text-width (car (gimp-text-get-extents-fontname text fontsize PIXELS font)))    

    text-width
    )
)

(define (text-wh text font fontsize)
(let*
    (
        (text-width 1)
        (text-height 1)
    )
    ;;;
    (set! text-width (car (gimp-text-get-extents-fontname text fontsize PIXELS font)))    
    ;;; ved ki a lista 2. elemét
    (set! text-height (elem 2  (gimp-text-get-extents-fontname text fontsize PIXELS font)))    
    ;;;    
    
    (list text-width text-height)
    )
)
]]></programlisting>
        <para>
           Majd a program definiálja a egy lokális változó segítségével, ami a let utasítás hozott létre a képnek a méretét.   
        </para>  
        <programlisting language="lisp"><![CDATA[
;(text-width "alma" "Sans" 100)

(define (script-fu-bhax-mandala text text2 font fontsize width height color gradient)
(let*
    (
        (image (car (gimp-image-new width height 0)))
        (layer (car (gimp-layer-new image width height RGB-IMAGE "bg" 100 LAYER-MODE-NORMAL-LEGACY)))
        (textfs)
        (text-layer)
        (text-width (text-width text font fontsize))
        ;;;
        (text2-width (car (text-wh text2 font fontsize)))
        (text2-height (elem 2 (text-wh text2 font fontsize)))
        ;;;
        (textfs-width)
        (textfs-height)
        (gradient-layer)
    )
]]></programlisting>
        <para>
            A car megint csak létrehozza a képet image változóban, layer-rel is hasonló műveletet végez csak más változóba kerül.
        </para> 
<programlisting language="lisp"><![CDATA[
    (gimp-image-insert-layer image layer 0 0)

    (gimp-context-set-foreground '(0 255 0))
    (gimp-drawable-fill layer FILL-FOREGROUND)
    (gimp-image-undo-disable image) 

    (gimp-context-set-foreground color)
]]></programlisting>
         <para>
            Újabb réteg kerül létrehozásra, ez fehérre lesz állítva, majd adunk egy "(gimp-context-set-foreground color)" függvényt, 
            ami tetszőleges szín kiválasztását teszi lehetővé a háttérnek.
        </para> 
<programlisting language="lisp"><![CDATA[
    (set! textfs (car (gimp-text-layer-new image text font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 -1)
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text-width 2))  (/ height 2))
    (gimp-layer-resize-to-image-size textfs)

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate-simple text-layer ROTATE-180 TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 2) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 4) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))
    
    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 6) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))    
]]></programlisting>
        <para>
            Következő program részletben, vesszük a szöveg adatait, mivel azokat elfogja helyezni a képen a megfelelő beállításokkal. 
            Létfontosságú a kép adatai is mivel, ehhez fog igazodni. Rétegek létrehozása meg azért is fontos mert ezekből fog összeállni 
            majd a mandala kép.
        </para>
<programlisting language="lisp"><![CDATA[
    (plug-in-autocrop-layer RUN-NONINTERACTIVE image textfs)
    (set! textfs-width (+ (car(gimp-drawable-width textfs)) 100))
    (set! textfs-height (+ (car(gimp-drawable-height textfs)) 100))
        
	(gimp-layer-resize-to-image-size textfs)
    
    (gimp-image-select-ellipse image CHANNEL-OP-REPLACE (- (- (/ width 2) (/ textfs-width 2)) 18) 
        (- (- (/ height 2) (/ textfs-height 2)) 18) (+ textfs-width 36) (+ textfs-height 36))
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)
        
    (gimp-context-set-brush-size 22)
    (gimp-edit-stroke textfs)
    
    (set! textfs-width (- textfs-width 70))
    (set! textfs-height (- textfs-height 70))
    
    (gimp-image-select-ellipse image CHANNEL-OP-REPLACE (- (- (/ width 2) (/ textfs-width 2)) 18) 
        (- (- (/ height 2) (/ textfs-height 2)) 18) (+ textfs-width 36) (+ textfs-height 36))
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)
        
    (gimp-context-set-brush-size 8)
    (gimp-edit-stroke textfs)
        
    (set! gradient-layer (car (gimp-layer-new image width height RGB-IMAGE "gradient" 100 LAYER-MODE-NORMAL-LEGACY)))
    
    (gimp-image-insert-layer image gradient-layer 0 -1)
	(gimp-image-select-item image CHANNEL-OP-REPLACE textfs)
	(gimp-context-set-gradient gradient) 
	(gimp-edit-blend gradient-layer BLEND-CUSTOM LAYER-MODE-NORMAL-LEGACY GRADIENT-RADIAL 100 0 
	REPEAT-TRIANGULAR FALSE TRUE 5 .1 TRUE (/ width 2) (/ height 2) (+ (+ (/ width 2) (/ textfs-width 2)) 8) (/ height 2))
	
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)

    (set! textfs (car (gimp-text-layer-new image text2 font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 -1)
    (gimp-message (number->string text2-height))
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text2-width 2)) (- (/ height 2) (/ text2-height 2)))
		
    ;(gimp-selection-none image)
    ;(gimp-image-flatten image)
    
    (gimp-display-new image)
    (gimp-image-clean-all image)
    )
)
]]></programlisting>
        <para>
            Ezután a rétegek összevonása és nagyítása következik. Szélesség 22 pixel lesz, belső kör meg 8. 
            Szövegre és körökre színátmenet lesz alkalmazva.
        </para>
<programlisting language="lisp"><![CDATA[
;(script-fu-bhax-mandala "Bátfai Norbert" "BHAX" "Ruge Boogie" 120 1920 1080 '(255 0 0) "Shadows 3")

(script-fu-register "script-fu-bhax-mandala"
    "Mandala9"
    "Creates a mandala from a text box."
    "Norbert Bátfai"
    "Copyright 2019, Norbert Bátfai"
    "January 9, 2019"
    ""
    SF-STRING       "Text"      "Bátf41 Haxor"
    SF-STRING       "Text2"     "BHAX"
    SF-FONT         "Font"      "Sans"
    SF-ADJUSTMENT   "Font size" '(100 1 1000 1 10 0 1)
    SF-VALUE        "Width"     "1000"
    SF-VALUE        "Height"    "1000"
    SF-COLOR        "Color"     '(255 0 0)
    SF-GRADIENT     "Gradient"  "Deep Sea"
)
(script-fu-menu-register "script-fu-bhax-mandala" 
    "<Image>/File/Create/BHAX"
)
]]></programlisting>
        <para>
            Végén megint csak a kezdőértékek megadása, és kép lementésére kerül sor.
        </para>            
    </section>        

<!--    
    <section>
        <title>Lambda</title>
        <para>
            Hasonlítsd össze a következő programokat!
        </para>
        <para>
            Megoldás videó: <link xlink:href=""></link>      
        </para>
        <para>
            Megoldás forrása: <link xlink:href=""></link>               
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>            
    </section>        
-->    

<!--
    <section>
        <title>Omega</title>
        <para>
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:                
        </para>
    </section>        
-->                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
</chapter>                
